#!/usr/bin/perl

$num = 4;
@keyword = ();

while ($_ = shift(@ARGV)) {
    if ($_ eq "-n") { $num = shift(@ARGV); }
    if ($_ eq "-k") { push(@keyword, shift(@ARGV)); }
}

@addr_insn = ();
@insn = ();

while (<>) {
    s/\n+$//;
    ($addr, $code, $dummy, $mnemonic)
	= /^\s*([0-9A-Fa-f]+)\:\s*(([0-9A-Fa-f]{2}\s)+)\s*(.*)/;

    if (!defined($mnemonic)) {
	@addr_insn = ();
	@insn = ();
	next;
    }

    $mnemonic =~ s/\s+$//;
    if ($mnemonic eq "") {
	next;
    }

    if (@insn >= $num) {
	shift(@addr_insn);
	shift(@insn);
    }
    push(@addr_insn, "$addr\t$mnemonic");
    push(@insn, $mnemonic);

    if ($mnemonic ne "ret") {
	next;
    }

    $insns = join('!!!', @insn);
    $found = 1;
    if (@keyword > 0) {
	$found = 0;
	foreach $k (@keyword) {
	    if ($insns =~ /$k/) {
		$found = 1;
		last;
	    }
	}
    }

    if (defined($appear{$insns})) {
	# nop
    } elsif (!$found) {
	# nop
    } else {
	$appear{$insns} = $addr;
	print "-------- $addr --------\n";
	foreach (@addr_insn) {
	    print "$_\n";
	}
    }

    @addr_insn = ();
    @insn = ();
}
